# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from homer_mapnav_msgs/ModifyMap.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class ModifyMap(genpy.Message):
  _md5sum = "1acd105b5e8f36cdca44d1da49528ddf"
  _type = "homer_mapnav_msgs/ModifyMap"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """int32 HIGH_SENSITIV = -2  # Area is highly sensitiv for Obstacles
int32 NOT_MASKED = -1     # Area is not masked: use slam map
int32 FREE = 0            # Area is free
int32 OBSTACLE = 99       # Area is occupied by an obstacle (e.g. 3d scan) 
int32 BLOCKED = 100       # Area blocked by user (use UNBLOCK to .. )
int32 HOKUYO = 101		  # Area is blocked by Hokuyo Obstacle
int32 KINECT = 102 		  # Area is blocked by Kinect Obstacle
int32 DEPTH = 102		  # Area is blocked by Depth Camera Obstacle
int32 RAPID = 103		  # Area is blocked by Rapid Mapping



int32 SET_FREE = 0      	  # Mark area free, area must not be BLOCKED
int32 SET_BLOCKED = 100       # Block area
int32 SET_OBSTACLE = 99   	  # Mark area as occupied by an obstacle (e.g. 3d scan)
int32 SET_HIGH_SENSITIV = -2  # Mark Area as highly sensitiv for Obstacles


geometry_msgs/Point[] region
int32 maskAction
int32 mapLayer #currently not used. modifications only take place in the masking map layer

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  # Pseudo-constants
  HIGH_SENSITIV = -2
  NOT_MASKED = -1
  FREE = 0
  OBSTACLE = 99
  BLOCKED = 100
  HOKUYO = 101
  KINECT = 102
  DEPTH = 102
  RAPID = 103
  SET_FREE = 0
  SET_BLOCKED = 100
  SET_OBSTACLE = 99
  SET_HIGH_SENSITIV = -2

  __slots__ = ['region','maskAction','mapLayer']
  _slot_types = ['geometry_msgs/Point[]','int32','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       region,maskAction,mapLayer

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ModifyMap, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.region is None:
        self.region = []
      if self.maskAction is None:
        self.maskAction = 0
      if self.mapLayer is None:
        self.mapLayer = 0
    else:
      self.region = []
      self.maskAction = 0
      self.mapLayer = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.region)
      buff.write(_struct_I.pack(length))
      for val1 in self.region:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_2i().pack(_x.maskAction, _x.mapLayer))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.region is None:
        self.region = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.region = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.region.append(val1)
      _x = self
      start = end
      end += 8
      (_x.maskAction, _x.mapLayer,) = _get_struct_2i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.region)
      buff.write(_struct_I.pack(length))
      for val1 in self.region:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_2i().pack(_x.maskAction, _x.mapLayer))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.region is None:
        self.region = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.region = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.region.append(val1)
      _x = self
      start = end
      end += 8
      (_x.maskAction, _x.mapLayer,) = _get_struct_2i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
