// Auto-generated. Do not edit!

// (in-package homer_mapnav_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class DriveToGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.goal_location = null;
      this.distance_to_target = null;
      this.suppress_speaking = null;
      this.skip_final_turn = null;
      this.stop_before_obstacle = null;
      this.plan_only_on_slam_map = null;
      this.check_obstacle = null;
    }
    else {
      if (initObj.hasOwnProperty('goal_location')) {
        this.goal_location = initObj.goal_location
      }
      else {
        this.goal_location = '';
      }
      if (initObj.hasOwnProperty('distance_to_target')) {
        this.distance_to_target = initObj.distance_to_target
      }
      else {
        this.distance_to_target = 0.0;
      }
      if (initObj.hasOwnProperty('suppress_speaking')) {
        this.suppress_speaking = initObj.suppress_speaking
      }
      else {
        this.suppress_speaking = false;
      }
      if (initObj.hasOwnProperty('skip_final_turn')) {
        this.skip_final_turn = initObj.skip_final_turn
      }
      else {
        this.skip_final_turn = false;
      }
      if (initObj.hasOwnProperty('stop_before_obstacle')) {
        this.stop_before_obstacle = initObj.stop_before_obstacle
      }
      else {
        this.stop_before_obstacle = false;
      }
      if (initObj.hasOwnProperty('plan_only_on_slam_map')) {
        this.plan_only_on_slam_map = initObj.plan_only_on_slam_map
      }
      else {
        this.plan_only_on_slam_map = false;
      }
      if (initObj.hasOwnProperty('check_obstacle')) {
        this.check_obstacle = initObj.check_obstacle
      }
      else {
        this.check_obstacle = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DriveToGoal
    // Serialize message field [goal_location]
    bufferOffset = _serializer.string(obj.goal_location, buffer, bufferOffset);
    // Serialize message field [distance_to_target]
    bufferOffset = _serializer.float32(obj.distance_to_target, buffer, bufferOffset);
    // Serialize message field [suppress_speaking]
    bufferOffset = _serializer.bool(obj.suppress_speaking, buffer, bufferOffset);
    // Serialize message field [skip_final_turn]
    bufferOffset = _serializer.bool(obj.skip_final_turn, buffer, bufferOffset);
    // Serialize message field [stop_before_obstacle]
    bufferOffset = _serializer.bool(obj.stop_before_obstacle, buffer, bufferOffset);
    // Serialize message field [plan_only_on_slam_map]
    bufferOffset = _serializer.bool(obj.plan_only_on_slam_map, buffer, bufferOffset);
    // Serialize message field [check_obstacle]
    bufferOffset = _serializer.bool(obj.check_obstacle, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DriveToGoal
    let len;
    let data = new DriveToGoal(null);
    // Deserialize message field [goal_location]
    data.goal_location = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [distance_to_target]
    data.distance_to_target = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [suppress_speaking]
    data.suppress_speaking = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [skip_final_turn]
    data.skip_final_turn = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [stop_before_obstacle]
    data.stop_before_obstacle = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [plan_only_on_slam_map]
    data.plan_only_on_slam_map = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [check_obstacle]
    data.check_obstacle = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.goal_location.length;
    return length + 13;
  }

  static datatype() {
    // Returns string type for a message object
    return 'homer_mapnav_msgs/DriveToGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c8ac2d4ddd994645de7e8e8b4bba281a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # The `driveTo` action navigates to an existing POI given by `goal_location`
    # up to a `distance_to_target`. Basically the `startNavigation` topic is wrapped
    # into a action.
    
    string goal_location # name of destination POI
    float32 distance_to_target # distance to destination POI
    bool suppress_speaking # toggles voice output, if false no debug speech is given else for starting action, target reached and target unreachable voice output is given
    bool skip_final_turn
    bool stop_before_obstacle
    bool plan_only_on_slam_map
    bool check_obstacle
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DriveToGoal(null);
    if (msg.goal_location !== undefined) {
      resolved.goal_location = msg.goal_location;
    }
    else {
      resolved.goal_location = ''
    }

    if (msg.distance_to_target !== undefined) {
      resolved.distance_to_target = msg.distance_to_target;
    }
    else {
      resolved.distance_to_target = 0.0
    }

    if (msg.suppress_speaking !== undefined) {
      resolved.suppress_speaking = msg.suppress_speaking;
    }
    else {
      resolved.suppress_speaking = false
    }

    if (msg.skip_final_turn !== undefined) {
      resolved.skip_final_turn = msg.skip_final_turn;
    }
    else {
      resolved.skip_final_turn = false
    }

    if (msg.stop_before_obstacle !== undefined) {
      resolved.stop_before_obstacle = msg.stop_before_obstacle;
    }
    else {
      resolved.stop_before_obstacle = false
    }

    if (msg.plan_only_on_slam_map !== undefined) {
      resolved.plan_only_on_slam_map = msg.plan_only_on_slam_map;
    }
    else {
      resolved.plan_only_on_slam_map = false
    }

    if (msg.check_obstacle !== undefined) {
      resolved.check_obstacle = msg.check_obstacle;
    }
    else {
      resolved.check_obstacle = false
    }

    return resolved;
    }
};

module.exports = DriveToGoal;
