// Auto-generated. Do not edit!

// (in-package homer_mapnav_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class ModifyMap {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.region = null;
      this.maskAction = null;
      this.mapLayer = null;
    }
    else {
      if (initObj.hasOwnProperty('region')) {
        this.region = initObj.region
      }
      else {
        this.region = [];
      }
      if (initObj.hasOwnProperty('maskAction')) {
        this.maskAction = initObj.maskAction
      }
      else {
        this.maskAction = 0;
      }
      if (initObj.hasOwnProperty('mapLayer')) {
        this.mapLayer = initObj.mapLayer
      }
      else {
        this.mapLayer = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ModifyMap
    // Serialize message field [region]
    // Serialize the length for message field [region]
    bufferOffset = _serializer.uint32(obj.region.length, buffer, bufferOffset);
    obj.region.forEach((val) => {
      bufferOffset = geometry_msgs.msg.Point.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [maskAction]
    bufferOffset = _serializer.int32(obj.maskAction, buffer, bufferOffset);
    // Serialize message field [mapLayer]
    bufferOffset = _serializer.int32(obj.mapLayer, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ModifyMap
    let len;
    let data = new ModifyMap(null);
    // Deserialize message field [region]
    // Deserialize array length for message field [region]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.region = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.region[i] = geometry_msgs.msg.Point.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [maskAction]
    data.maskAction = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [mapLayer]
    data.mapLayer = _deserializer.int32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 24 * object.region.length;
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'homer_mapnav_msgs/ModifyMap';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '1acd105b5e8f36cdca44d1da49528ddf';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    int32 HIGH_SENSITIV = -2  # Area is highly sensitiv for Obstacles
    int32 NOT_MASKED = -1     # Area is not masked: use slam map
    int32 FREE = 0            # Area is free
    int32 OBSTACLE = 99       # Area is occupied by an obstacle (e.g. 3d scan) 
    int32 BLOCKED = 100       # Area blocked by user (use UNBLOCK to .. )
    int32 HOKUYO = 101		  # Area is blocked by Hokuyo Obstacle
    int32 KINECT = 102 		  # Area is blocked by Kinect Obstacle
    int32 DEPTH = 102		  # Area is blocked by Depth Camera Obstacle
    int32 RAPID = 103		  # Area is blocked by Rapid Mapping
    
    
    
    int32 SET_FREE = 0      	  # Mark area free, area must not be BLOCKED
    int32 SET_BLOCKED = 100       # Block area
    int32 SET_OBSTACLE = 99   	  # Mark area as occupied by an obstacle (e.g. 3d scan)
    int32 SET_HIGH_SENSITIV = -2  # Mark Area as highly sensitiv for Obstacles
    
    
    geometry_msgs/Point[] region
    int32 maskAction
    int32 mapLayer #currently not used. modifications only take place in the masking map layer
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ModifyMap(null);
    if (msg.region !== undefined) {
      resolved.region = new Array(msg.region.length);
      for (let i = 0; i < resolved.region.length; ++i) {
        resolved.region[i] = geometry_msgs.msg.Point.Resolve(msg.region[i]);
      }
    }
    else {
      resolved.region = []
    }

    if (msg.maskAction !== undefined) {
      resolved.maskAction = msg.maskAction;
    }
    else {
      resolved.maskAction = 0
    }

    if (msg.mapLayer !== undefined) {
      resolved.mapLayer = msg.mapLayer;
    }
    else {
      resolved.mapLayer = 0
    }

    return resolved;
    }
};

// Constants for message
ModifyMap.Constants = {
  HIGH_SENSITIV: -2,
  NOT_MASKED: -1,
  FREE: 0,
  OBSTACLE: 99,
  BLOCKED: 100,
  HOKUYO: 101,
  KINECT: 102,
  DEPTH: 102,
  RAPID: 103,
  SET_FREE: 0,
  SET_BLOCKED: 100,
  SET_OBSTACLE: 99,
  SET_HIGH_SENSITIV: -2,
}

module.exports = ModifyMap;
