// Auto-generated. Do not edit!

// (in-package homer_mapnav_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let RegionOfInterest = require('../msg/RegionOfInterest.js');

//-----------------------------------------------------------

class PointInsideRoisRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.point = null;
    }
    else {
      if (initObj.hasOwnProperty('point')) {
        this.point = initObj.point
      }
      else {
        this.point = new geometry_msgs.msg.PointStamped();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PointInsideRoisRequest
    // Serialize message field [point]
    bufferOffset = geometry_msgs.msg.PointStamped.serialize(obj.point, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PointInsideRoisRequest
    let len;
    let data = new PointInsideRoisRequest(null);
    // Deserialize message field [point]
    data.point = geometry_msgs.msg.PointStamped.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PointStamped.getMessageSize(object.point);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'homer_mapnav_msgs/PointInsideRoisRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '47dfdbd810b48d0a47b7ad67e4191bcc';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    geometry_msgs/PointStamped point
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PointInsideRoisRequest(null);
    if (msg.point !== undefined) {
      resolved.point = geometry_msgs.msg.PointStamped.Resolve(msg.point)
    }
    else {
      resolved.point = new geometry_msgs.msg.PointStamped()
    }

    return resolved;
    }
};

class PointInsideRoisResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.rois = null;
    }
    else {
      if (initObj.hasOwnProperty('rois')) {
        this.rois = initObj.rois
      }
      else {
        this.rois = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PointInsideRoisResponse
    // Serialize message field [rois]
    // Serialize the length for message field [rois]
    bufferOffset = _serializer.uint32(obj.rois.length, buffer, bufferOffset);
    obj.rois.forEach((val) => {
      bufferOffset = RegionOfInterest.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PointInsideRoisResponse
    let len;
    let data = new PointInsideRoisResponse(null);
    // Deserialize message field [rois]
    // Deserialize array length for message field [rois]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.rois = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.rois[i] = RegionOfInterest.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.rois.forEach((val) => {
      length += RegionOfInterest.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'homer_mapnav_msgs/PointInsideRoisResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '33c71bd88a4369cff2d23af502b4c949';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    homer_mapnav_msgs/RegionOfInterest[]  rois
    
    
    ================================================================================
    MSG: homer_mapnav_msgs/RegionOfInterest
    #ROI types
    int32 DEFAULT=100
    int32 ROOM=200
    int32 AREA=300
    int32 FORBIDDEN_AREA=400
    
    int32 type
    string name
    string remarks
    
    int32 id
    geometry_msgs/Point[4] points
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PointInsideRoisResponse(null);
    if (msg.rois !== undefined) {
      resolved.rois = new Array(msg.rois.length);
      for (let i = 0; i < resolved.rois.length; ++i) {
        resolved.rois[i] = RegionOfInterest.Resolve(msg.rois[i]);
      }
    }
    else {
      resolved.rois = []
    }

    return resolved;
    }
};

module.exports = {
  Request: PointInsideRoisRequest,
  Response: PointInsideRoisResponse,
  md5sum() { return 'd2dd7b091045cb40dd270b0da2d7dba9'; },
  datatype() { return 'homer_mapnav_msgs/PointInsideRois'; }
};
